///////////////////////////////////////////////////////////////////////////////////////////////
//							      
//							http://www.interestprograms.ru
//
//////////////////////////////////////////////////////////////////////////////////////////////

// ChildView.cpp : implementation of the CChildView class
//

#include "stdafx.h"
#include "ExRgnMfc.h"
#include "ChildView.h"
#include ".\childview.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif





// CChildView

CChildView::CChildView()
{
}

CChildView::~CChildView()
{
	//     
	//    
	DeleteGDIObject(&m_Bitmap);
	DeleteGDIObject(&m_RgnGdi);
}


BEGIN_MESSAGE_MAP(CChildView, CWnd)
	ON_WM_PAINT()
	ON_COMMAND(ID_TEST_1, OnTest1)
	ON_COMMAND(ID_TEST_2, OnTest2)
	ON_COMMAND(ID_TEST_3, OnTest3)
	ON_WM_KEYDOWN()
	ON_COMMAND(ID_TEST_4, OnTest4)
	ON_COMMAND(ID_TEST_5, OnTest5)
	ON_COMMAND(ID_TEST_6, OnTest6)
END_MESSAGE_MAP()



// CChildView message handlers

BOOL CChildView::PreCreateWindow(CREATESTRUCT& cs) 
{
	if (!CWnd::PreCreateWindow(cs))
		return FALSE;

	cs.dwExStyle |= WS_EX_CLIENTEDGE;
	cs.style &= ~WS_BORDER;
	cs.lpszClass = AfxRegisterWndClass(CS_HREDRAW|CS_VREDRAW|CS_DBLCLKS, 
		::LoadCursor(NULL, IDC_ARROW), reinterpret_cast<HBRUSH> (GetStockObject(BLACK_BRUSH)), NULL);

	return TRUE;
}

void CChildView::OnPaint() 
{
	CPaintDC dc(this); // device context for painting
	
	if(m_Bitmap.m_hObject != NULL)
		dc.DrawState(CPoint(0,0), m_Bitmap.GetBitmapDimension(), &m_Bitmap, DST_BITMAP);


	if(m_RgnGdi.m_hObject != NULL)
	{
		dc.PaintRgn(&m_RgnGdi);
	}

	
	// Do not call CWnd::OnPaint() for painting messages
}



//  
void CChildView::OnTest1()
{
	SetWinRgn(IDR_RGN1, IDB_BITMAP1);
}

void CChildView::OnTest2()
{
	SetWinRgn(IDR_RGN2, IDB_BITMAP2);
}

void CChildView::OnTest3()
{
	SetWinRgn(IDR_RGN3, IDB_BITMAP3);
}

void CChildView::OnTest4()
{
	SetGDIRgn(IDR_RGN1);
}

void CChildView::OnTest5()
{
	SetGDIRgn(IDR_RGN2);
}

void CChildView::OnTest6()
{
	SetGDIRgn(IDR_RGN3);
}



void CChildView::SetWinRgn(UINT id_rgn, UINT id_bitmap)
{
	//      
	DeleteGDIObject(&m_RgnGdi);

	//   (  )    
	DeleteGDIObject(&m_Bitmap);

	//     
	m_Bitmap.LoadBitmap(id_bitmap);

	//     
	//      ,    
	CRgn rgn;
	HINSTANCE hInst = AfxGetApp()->m_hInstance;
	HRSRC hrRgn = FindResource(hInst, MAKEINTRESOURCE(id_rgn),"RGN");
	LPRGNDATA pRgnData = (LPRGNDATA)LoadResource(hInst, hrRgn);
	rgn.CreateFromData(NULL, SizeofResource(hInst,hrRgn), pRgnData);
	FreeResource(pRgnData);

	//      , 
	//     
	CRect rc_frame, rc_wnd;
	AfxGetMainWnd()->GetWindowRect(&rc_frame);
	GetClientRect(&rc_wnd);
	ClientToScreen(&rc_wnd);
	int left = rc_wnd.left	- rc_frame.left;
	int top  = rc_wnd.top	- rc_frame.top;
	rgn.OffsetRgn( left, top);


	//       
	AfxGetMainWnd()->SetWindowRgn(rgn, TRUE);

	//  
	Invalidate();
}

//      
void CChildView::SetGDIRgn(UINT id_rgn)
{
	//      ,    
	DeleteGDIObject(&m_Bitmap);

	
	//     
	//        
	//      
	DeleteGDIObject(&m_RgnGdi);
	
	HINSTANCE hInst = AfxGetApp()->m_hInstance;
	HRSRC hrRgn = FindResource(hInst, MAKEINTRESOURCE(id_rgn),"RGN");
	LPRGNDATA pRgnData = (LPRGNDATA)LoadResource(hInst, hrRgn);
	m_RgnGdi.CreateFromData(NULL, SizeofResource(hInst,hrRgn), pRgnData);
	FreeResource(pRgnData);

	//  
	Invalidate();
	
}


void CChildView::OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags)
{
	//    ESC,    
	if(nChar == VK_ESCAPE)
	{
		AfxGetMainWnd()->SetWindowRgn(NULL, TRUE);
	}

	CWnd::OnKeyDown(nChar, nRepCnt, nFlags);
}





//    GDI 
void CChildView::DeleteGDIObject(CGdiObject* gdi_object)
{
	if(gdi_object->m_hObject != NULL)
		gdi_object->DeleteObject();

}
